﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using Microsoft.Kinect;

namespace Kinect_ARsensing
{
    class NTL_SkeletonData
    {
        public struct Vector
        {
           public float X;
           public float Y;
           public float Z;
        }

        public Vector[] JointPosition = new Vector[20]; //【KINECTセンサのSkeletonPointはPlayer当り20点】
        public Vector[] Bone = new Vector[19];          //【Boneベクトル】 
        public JointType[] JointList = //列挙型が面倒なので通常のVector3配列に変換する為のデータ
        {  JointType.Head, JointType.ShoulderCenter, JointType.Spine, JointType.HipCenter,
           JointType.ShoulderLeft, JointType.ElbowLeft, JointType.WristLeft, JointType.HandLeft,
           JointType.ShoulderRight,JointType.ElbowRight,JointType.WristRight,JointType.HandRight,
           JointType.HipLeft,JointType.KneeLeft,JointType.AnkleLeft,JointType.FootLeft,
           JointType.HipRight,JointType.KneeRight,JointType.AnkleRight,JointType.FootRight
        };
        public int[] BoneIndexList = //Boneベクトルを計算するためのインデックスリスト(始点,終点の順)
        { 1, 0, 2, 1, 1, 4, 4, 5, 5, 6, 6, 7, 1, 8, 8, 9, 9, 10, 10, 11, 2, 3, 3, 12, 12, 13, 13, 14, 14, 15, 3, 16, 16, 17, 17, 18, 18, 19 };
        // 首,上半身,左肩,左上腕,左腕,左手,右肩,右上腕,右腕,右手,下半身,左尻,左太腿,左脹脛,左足,右尻,右太腿,右脹脛,右足

        public void SetBody(KinectSensor ks, Skeleton SkD, bool flg)
        {
            int i;
            ColorImagePoint p;
            SkeletonPoint q;

            for (i = 0; i < JointPosition.Length; i++)
            {
                q = SkD.Joints[JointList[i]].Position;
                if (flg) { q.X = -q.X; }
                p = ks.MapSkeletonPointToColor(q, ColorImageFormat.RgbResolution640x480Fps30);
                JointPosition[i].X = p.X; JointPosition[i].Y = p.Y;
            }
            for (i = 0; i < Bone.Length; i++)
            {   //ここでは使わないが、Boneベクトルを演算
                Bone[i].X = JointPosition[BoneIndexList[2 * i + 1]].X - JointPosition[BoneIndexList[2 * i]].X;
                Bone[i].Y = JointPosition[BoneIndexList[2 * i + 1]].Y - JointPosition[BoneIndexList[2 * i]].Y;
            }
        }
    }
}
